#!/usr/bin/python
import xmlrpclib, sys

def send(maily, clientlocation, host="http://localhost:8080/", username=None, password=None):
	import string
	
	s=xmlrpclib.Server(host, transport=None, username=username, password=password)
	
	clientlocation = string.replace(clientlocation,'/','.')
	print clientlocation
		
	try:
		exec """client = s.%s""" % (clientlocation,) 
		result = client.postZMailMessage(maily['id'], maily['title'], maily['subject'], maily['date'], maily['to'], maily['sender'], maily['replyto'], maily['body'], maily['headers'])
	except xmlrpclib.ProtocolError,e:
		print "Fail: Protocol Error",e
		return 1
	
	if (result[-4:]!='OK!'):
		print 'Fail'
		return 1
	else:
		print 'Success'
		return 0
	
def getClientInfo(zopedir, to):
	try:
		f = open(zopedir+'/var/ZMailIn.loc')
		line = f.readline()
		while line:
			if line[:len(to)] == to:
				return line[len(to)+4:-1]
		
			line = f.readline()
	
		print "Unable to find ZMailIn for",to
		return 0
		
	except IOError:
		print "IOError with file ZMailIn.loc, it may not exist"
		return 0
	

if __name__ == '__main__':
	import zopeMailInConf
	
	import rfc822
	f = sys.stdin
	m = rfc822.Message(f)
		
	myMail = {}
	myMail['headers']=m.items()
	myMail['body']=m.fp.read()
	myMail['id']=m['message-id'][1:-1]
	myMail['title']=''
	myMail['sender']=''
	myMail['replyto']=''
	
	headerslist = [['subject','title'],['from','sender'],['reply-to','sender'],['subject','subject'],['date','date'],['to','to']]
	
	for header in headerslist:
		if m.has_key(header[0]):
			myMail[header[1]]=m[header[0]]
	
	if m.has_key('envelope-to'):
		myMail['to'] = m['envelope-to']
	else:
		print "No envelope-to header. Please configure your MTP"
		sys.exit(1)
	
	clientlocation = getClientInfo(zopeMailInConf.zopedir, myMail['to'])
	if clientlocation != 0:
	
		if send(myMail, clientlocation, zopeMailInConf.host, zopeMailInConf.username, zopeMailInConf.password):
			# 73 is a standard error code.
			# It means EX_CANTCREAT
			sys.exit(73)
		else:
			sys.exit(0)
	else:
		sys.exit(1)